.386c
XCRK_text	segment byte public 'CODE' use32
		assume cs:XCRK_text
HASP_API proc
			cmp	cx, 576dh
			je	RascF

			cmp	bh, 2		; GetSeedCode
			je	SeedCodes
			cmp	bh, 3
			je	ReadMemo
	ReadMemo:
			call	@@ip		; get relocation data
		@@ip:	pop	ebp
C$Rel		=	offset @@ip

			lea	ebx, offset HASPMemD + [ebp] - C$Rel
			shl	edi, 1		; Word access (DI*2)
			movzx	ebx, word ptr [ebx+edi]	; return fake data
			shr	edi, 1		; Restore DI
			mov	eax, edi
			xor     ecx,ecx		; HASP work properly
			ret
	SeedCodes:				; BH=2
			cmp	ax, 0
			je	_0000
			cmp	ax, 018Bh
			je	_018B
			cmp	ax, 01724h
			je	_1724
			cmp	ax, 02C8Fh
			je	_2C8F
			cmp	ax, 08A53h
			je	_8A53
			_0000:
			mov	ax, 0f458h
			xor	bx, bx
			xor	cx, cx
			xor	dx, dx
			ret
			_018B:
			mov	ax, 0F9F5h
			mov	bx, 0C7C9h
			mov	cx, 03D9Eh
			mov	dx, 01486h
			ret
			_1724:
			mov	ax, 009EDh
			mov	bx, 0F638h
			mov	cx, 0FB38h
			mov	dx, 02862h
			ret
			_2C8F:
			mov	ax, 05A01h
			mov	bx, 01507h
			mov	cx, 08E03h
			mov	dx, 04B56h
			ret
			_8A53:
			mov	ax, 0ACEAh
			mov	bx, 0E882h
			mov	cx, 07D4Ah
			mov	dx, 087F6h
			ret
HASPMemD 		dw	0,0,4Dh,64h,0,1,7,12h,1Fh,30h,44h
			dw	5Bh,75h,92h,0B3h,0D6h,0FDh,0,20h,5Fh,1,0
			dw	0,0,5
;
RascF:
			cmp	bh, 2		; GetSeedCode
			je	rSeedCodes
			cmp	bh, 3
			je	rReadMemo
	rReadMemo:
			call	@@rip		; get relocation data
		@@rip:	pop	ebp
rC$Rel		=	offset @@rip

			lea	ebx, offset rHASPMemD + [ebp] - rC$Rel
			shl	edi, 1		; Word access (DI*2)
			movzx	ebx, word ptr [ebx+edi]	; return fake data
			shr	edi, 1		; Restore DI
			mov	eax, edi
			xor     ecx,ecx		; HASP work properly
			ret
	rSeedCodes:				; BH=2
			cmp	ax, 01125h
			je	_1125
			cmp	ax, 0194dh
			je	_194d
			cmp	ax, 0c0beh
			je	_c0be
			cmp	ax, 0f512h
			je	_f512

			mov	ax, 0f458h
			xor	bx, bx
			xor	cx, cx
			xor	dx, dx
			ret
			_1125:
			mov	ax, 09da8h
			mov	bx, 07824h
			mov	cx, 0b2b6h
			mov	dx, 0a228h
			ret
			_F512:
			mov	ax, 0202eh
			mov	bx, 0e02eh
			mov	cx, 05b14h
			mov	dx, 08259h
			ret
			_c0be:
			mov	ax, 0a892h
			mov	bx, 0865ah
			mov	cx, 02f5ch
			mov	dx, 0faf8h
			ret
			_194d:
			mov	ax, 0192eh
			mov	bx, 0c1b0h
			mov	cx, 025c4h
			mov	dx, 03de4h
			ret
;
;			 0    1    2    3    4    5    6    7    8    9
rHASPMemD	dw	000h,000h,04Dh,064h,000h,001h,007h,012h,01Fh,030h
		dw	044h,05bh,075h,092h,0B3h,0D6h,0FDh,000h,020h,05Fh
		dw	002h,000h,000h,000h,005h

HASP_API endp
XCRK_text	ends
		end HASP_API
