PAGE	59,132
TITLE	 HASP-Emulator , (c)1996-97 by MeteO
%DEPTH 0
%LINUM 3
Locals $$
.XLIST
;
;									      
;				  HASP Emulation kernel			      
;									      
;	Created: 22.04.97 19:10  					      
;	Version: 1.34.000 (1st release)				      	      
;	Copyright (C) 1996-97 MeteO 					      
;									      
;	This is the HASP emulation kernel for KeyInst (GARANT (tm))	      
;									      
;	We assumes no responsibility on any side-effect in using this code    
;									      
;
.386c
.LIST
;
$Progname		Equ	'HASP-Emu'
Copyright		Equ     '(x)1997 by MeteO '
$ver$			Equ	'1.34.017c'
;
NOSTRINGS		Equ	Yes	; If add-on string not allowed
;_FOXPRO_		Equ	Yes
;_PASCAL_		Equ	Yes
;_C_			Equ	Yes
;DPMIVER			Equ	Yes
;
HASPEmu_text	segment byte public 'CODE' use16
		assume cs:HASPEmu_text,ds:HASPEmu_text
		org 100h
;
start:
include hasphdr.inc
;
;
;
phuck_hasp proc near


			push	ax bx cx dx si di bp ds cs
			pop	ds		; Equ cs=ds


			call	@@ip		; get relocation data
		@@ip:	pop	bp
C$Rel		=	offset @@ip
;
IFNDEF NOSTRINGS
include colorate.inc
ENDIF
;
IFDEF DPMIVER

			mov	ax, 0	; Allocate LDT selector
			mov	cx, 1
			int	31h

			mov	ax, 0ah	; CStoDSalias
			mov	bx, cs
			int	31h
			mov	ds, ax
			pop	bx ax
ENDIF
;
; LODS - alghoritm (x) 1993-97 by Max Q.Deckert 
; AT BH: func
;
			push	ax cx di es cs
			pop	es

	  		std
			mov	al, bh
	  		lea	di, offset KeyTbl+_KeyTbl-1 + [bp] - C$Rel
	  		mov	cx, _KeyTbl
	  	repne	scasb

			cmp	cx, -1		; or	cx, cx
	       		jz	HASP_Quit	; no such function

			cld
			shl	cx, 1		; CX*2 (at CX - counter)
			lea	bx, KeyHandle + [bp] - C$Rel
			add	bx, cx		; offset to func
			mov	bx, [bx]	; get XLAT func offset
			add	bx, bp		; add on relocs

			pop	es di cx ax
	  		jmp	bx

;
_NET_LOGIN:
_TIME_SET_TIME:
_TIME_SET_DATE:
_TIME_GET_DATE:
_TIME_GET_TIME:
FAILED:
			mov	cx, -999	; Failed ;( not supported)
			jmp	short HASP_Quit

;
;
Save_value:
			mov	bp, sp
			mov	[bp+4], di
			mov	[bp+6], si
			mov	[bp+8], dx
			mov	[bp+10], cx
			mov	[bp+12], bx
			mov	[bp+14], ax

	HASP_Quit:
IFDEF DPMIVER
			mov	ax, 1
			mov	bx, ds
			int	31h
ENDIF


			pop	ds bp di si dx cx bx ax
IFDEF _C_
		retf
ELSE
		ret
ENDIF



;
; HASP kernel
;
;

_NET_LOGOUT:
_NET_LAST_STATUS:
			xor	ax, ax		; Return OK
			jmp	short BXCX
_HASP_INSTALLED:
			mov	ax, 1		; HASP is instaled
		BXCX:
			xor	bx, bx		; clear BX
			mov	cx, OK		; HASP work properly
			jmp	short Save_value
;
_GET_HASP_STATUS:

			mov	ax, 1 		; Memory size
			mov	bx, ax		; HASP type
			mov	cx, ax		; Actual LPT Num
			jmp	short Save_value
;
_GET_ID_NUM:
_NET_GET_ID_NUMBER:
_TIME_GET_ID_NUM:
			call	ReadHeader
			lea	bx, offset Dmp._sn +[bp] - C$Rel

			mov	ax, [bx]	; Get IDHigh
			mov	bx, [bx+2]	; Get IDLow
			mov	cx, Ok
			jmp	short Save_value
;
;
_HASP_CODE:
_NET_GET_HASP_CODE:

			call	OpenFile
			jc      FAILED
			and	ax, 0111111111111111b ; Clear 7 bit

			add	ax, size Dmp/(4*2)	; add Buffer offset
			mov	dx, 4*2		; 4 word read
			mul	dx

			mov	cx, dx		; DX=65535 CX=actual offset
			xchg	dx, ax

			call	Lseek42
			mov	cx, 4*2		; Read 4 words
			call	ReadBuf

			call	CloseFile
			mov	bx, dx		; Offset to Seed code Buffer

			mov	ax, [bx]	; Store seed codes
			mov	cx, [bx+4]
			mov	dx, [bx+6]
			mov	bx, [bx+2]
			jmp	Save_value

;
_READ_MEMO:
_NET_READ_WORD:
_TIME_READ_MEMORY:
			call	ReadHeader

			lea	bx, offset Dmp._bf + [bp] - C$Rel
			shl	di, 1		; Word access (DI*2)
			mov	bx, [bx+di]	; return fake data
			shr	di, 1		; Restore DI
			mov	ax, di		; ?? API compatibility
			mov	cx, OK		; HASP work properly
			jmp	Save_value

;
_WRITE_MEMO:
_NET_WRITE_WORD:
_TIME_WRITE_MEMORY:
			lea	bx, offset Dmp._bf + [bp] - C$Rel
			shl	di, 1		; Word access (DI*2)
			mov	[bx+di], si	; save fake data
			shr	di, 1		; Restore DI
			mov	ax, di		; ?? API compatibility
			mov	cx, OK		; HASP work properly
			jmp	Save_value
;
; AT	DI - start memo addr
;	SI - block length
;	ES:AX - offset

_MEMOHASP_READ_BLOCK:
_NET_READ_MEMO_BLOCK:
_TIME_READ_MEMORY_BLOCK:
			call	ReadHeader
			lea	bx, offset Dmp._bf + [bp] - C$Rel
			mov	cx, si		; rep counter
			lea	si, [bx+di]     ; get source addr
			xchg    di, ax		; get destination addr
		repe	movsw			; start to store ES:DI<-DS:SI
			mov	cx, OK		; OK ;)
			jmp	Save_value

;
; AT	DI - start memo addr
;	SI - block length
;	ES:AX - offset
_MEMOHASP_WRITE_BLOCK:
_NET_WRITE_MEMO_BLOCK:
_TIME_WRITE_MEMORY_BLOCK:
			mov	cx, si		; rep counter
			lea	bx, offset Dmp._bf + [bp] - C$Rel
			lea	di, [bx+di]	; set destination
			xchg	si, ax		; set source addr
			push	es es cs
			pop	es ds

		repe	movsw			; start to store ES:DI<-DS:SI
			mov	cx, OK		; OK ;)
			pop	es		; restore source
			jmp	Save_value

phuck_hasp endp
; Misc functions
ReadHeader:
			cmp	byte ptr (bReadFlag+[bp]-C$Rel), 1
			jz	$$2
			ret
		$$2:
			call	OpenFile
			jc      FAILED
			xor	cx, cx
			xor	dx, dx
			call	Lseek42
			mov	cx, size Dmp
			call	ReadBuf		; Read from file
			push	di es cs	; Equ ES:CS
			pop	es
			lea	si, Buf + [bp] - C$Rel
			lea	di, Dmp + [bp] - C$Rel
			mov	cx, size Dmp
		repe	movsb
			mov	byte ptr (bReadFlag+[bp]-C$Rel), 1	; Already read
			call	CloseFile

			pop	es di		; restore from game ;)
			ret
OpenFile:
			push	ax bx cx dx si di
			lea	dx, offset DmpName + [bp] - C$Rel
	r_open:
			mov	ax, 3D00h
			int	21h
			jnc	found
			cmp	al, 02h		; Not found
			stc
			jne	_q$of

			mov	ah, 51h		; Get PSP query
			int	21h

			xor	di, di

			dec	bx		; Get MCB
			mov	es, bx
			mov	cx, word ptr es:[di+3h]
			inc	cx

			push	cx
			mov	es, word ptr es:[di+10h+2ch]; DOS environment
			lea	si, offset ScanString + [bp] - C$Rel
			call	Search32k
			pop	cx
			jc	_q$of		; Scan string HASPDUMP not fnd

			mov	al, '='		; scan to "="
		repne	scasb

			push	es di		; XCHG reg
			pop	si ds

		_filn:
			lodsb			; get AL<-DS:SI
			cmp	al, 09h		; <TAB>
			je	_filn
			cmp	al, 20h		; <SPACE>
			je	_filn

			dec	si
			mov	dx, si
			jmp	r_open

		found:
			clc			; Succeful open
			lea	bx, wHandle + [bp] - C$Rel
			mov	[bx], ax	; Save handle
		_q$of:
			pop	di si dx cx bx ax
		ret
;
CloseFile:
			push	ax bx
			mov	ah, 3eh		; Close handle
			jmp	short _File
;
Lseek42:
			push	ax bx
			mov	ax, 4200h	; From begin of file
	_File:
			lea	bx, wHandle + [bp] - C$Rel
			mov	bx, [bx]        ; Get handle
						; Return BX-handle
			int	21h
			pop	bx ax
		ret
; At CX - num bytes to read
ReadBuf:
			push	ax bx
			lea	dx, offset Buf + [bp] - C$Rel
			mov	ah, 3fh 	; Read bytes
			jmp	short _FIle
;
;
;		SUBROUTINE Search bytes
;
Search32k proc
		cld
		lodsb             	; load 1st byte of code (59h)
	$Scan:
		repne	scasb
		jne	$Fail

		push	cx		; Save old value
		lea	si, offset ScanString + [bp] - C$Rel

		dec	di
		mov	cx, _ScanString
	rep	cmpsb

		or	cx, cx		; Ok, no mismatch found
		pop	cx		; restore

		jnz	$Scan

	$Quit:	clc		; Ok found and patched
	ret

	$Fail:
		stc		; Ne found ;)
	ret


Search32k endp
;
KeyTbl		db	HASP_INSTALLED,HASP_CODE,READ_MEMO,WRITE_MEMO
		db	GET_HASP_STATUS,GET_ID_NUM,NET_LAST_STATUS
		db	NET_GET_HASP_CODE,NET_LOGIN,NET_LOGOUT,NET_READ_WORD
		db	NET_WRITE_WORD,NET_GET_ID_NUMBER,MEMOHASP_READ_BLOCK
		db	MEMOHASP_WRITE_BLOCK,NET_READ_MEMO_BLOCK
		db	NET_WRITE_MEMO_BLOCK,TIME_SET_TIME,TIME_GET_TIME
		db	TIME_SET_DATE,TIME_GET_DATE,TIME_WRITE_MEMORY
		db	TIME_READ_MEMORY,TIME_WRITE_MEMORY_BLOCK
		db	TIME_READ_MEMORY_BLOCK,TIME_GET_ID_NUM
_KeyTbl		Equ	$-KeyTbl
KeyHandle	dw	offset _HASP_INSTALLED-C$Rel, offset _HASP_CODE-C$Rel
		dw	offset _READ_MEMO-C$Rel, offset _WRITE_MEMO-C$Rel
		dw	offset _GET_HASP_STATUS-C$Rel, offset _GET_ID_NUM-C$Rel
		dw	offset _NET_LAST_STATUS-C$Rel, offset _NET_GET_HASP_CODE-C$Rel
		dw	offset _NET_LOGIN-C$Rel, offset _NET_LOGOUT-C$Rel
		dw	offset _NET_READ_WORD-C$Rel, offset _NET_WRITE_WORD-C$Rel
		dw	offset _NET_GET_ID_NUMBER-C$Rel, offset _MEMOHASP_READ_BLOCK-C$Rel
		dw	offset _MEMOHASP_WRITE_BLOCK-C$Rel, offset _NET_READ_MEMO_BLOCK-C$Rel
		dw	offset _NET_WRITE_MEMO_BLOCK-C$Rel, offset _TIME_SET_TIME-C$Rel
		dw	offset _TIME_GET_TIME-C$Rel, offset _TIME_SET_DATE-C$Rel
		dw	offset _TIME_GET_DATE-C$Rel, offset _TIME_WRITE_MEMORY-C$Rel
		dw	offset _TIME_READ_MEMORY-C$Rel, offset _TIME_WRITE_MEMORY_BLOCK-C$Rel
		dw	offset _TIME_READ_MEMORY_BLOCK-C$Rel, offset _TIME_GET_ID_NUM-C$Rel
;;
;; Misc strings
IFNDEF NOSTRINGS
db		13,10,13,10,'GSM-text must b free! Delta - suxx, GSM rules!',13,10,13,10
; What is HASP mean
;
msgHASP_suxx	 db	0dh,'HASP - suxx!', 1ah, 0
ENDIF
; Misc program variables
ScanString:
_ScanString	equ	8		; 8 chars, e.g. HASPDUMP
DmpName			db	'HASPDUMP.bin', 0
;
;
wHandle			dw	?	; DmpName HANDLE
bReadFlag		dw	?	; 'Is header readed?' flag
;
; Include here HASP non-volatile memory data
;
Dmp	_HaspDumpHdr	<>
;
;
Buf:
m_Herald		db	13, 10, '',$ProgName,' v'
			db	$ver$
			db	Copyright
			db	'(',??Date,' ',??Time,')'
IFNDEF NOSTRINGS
			db	'(DEBUG)'
ENDIF
;
IFDEF _PASCAL_
			db	'(PASCAL)'
ENDIF
;
IFDEF _C_
			db	'(C)'
ENDIF
;
IFDEF _FOXPRO_
			db	'(FOXPRO)'
ENDIF
;
			db	0
			db	13,10,'$'
; For KeyInst(tm)
;
; include	dtahasp1.inc
;
;
;
HASPEmu_text	ends
                END start
